SystemOrganization addCategory: #'Seaside-Welcome'!

WAFileLibrary subclass: #WAWelcomeFiles
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Welcome'!

!WAWelcomeFiles commentStamp: '<historical>' prior: 0!
A WAFileLibrary derived class for the WAWelcome* classes
!

!WAWelcomeFiles methodsFor: 'accessing' stamp: 'NickAger 5/23/2010 11:35'!
selectorsToInclude
	^ #( syntaxHighlightingCss welcomeCss )! !

!WAWelcomeFiles methodsFor: 'accessing' stamp: 'NickAger 5/23/2010 13:12'!
syntaxHighlightingCss	^ '
span.patternUnary  {
color:#000000;
font-weight:bold;
}

span.patternKeyword  {
color:#000000;
font-weight:bold;
}

span.patternArg {
color:#000088;
}

span.super  {
color:#008888;
}

span.instanceVar  {
color:#000088;
}

span.number  {
color:#880088;
}

span.receiver  {
color:#000088;
}

span.keyword  {
color:#000000;
}

span.string  {
color:#880088;
}

span.blockArg  {
color:#000088;
}

span.class  {
color:#000088;
}

span.self  {
color:#008888;
}

span.symbol  {
color:#880088;
}
'! !

!WAWelcomeFiles methodsFor: 'accessing' stamp: 'NickAger 6/9/2010 12:53'!
welcomeCss	^ '
body{
	border:0 none;
	margin:0;
	padding:0;
}	
	
.content {
	margin: 10px;
}

.header {
	background: #DCEBED;
	height: 50px;
}

.headerImage {
	float:left;
}

.headerText {
	padding: 10px;
}

.introText {
	margin-top: 20px;
}

a img {
	border: none;
}

.introTable {
	border-spacing:0 5px;
	padding: 0;
	border-collapse: separate;
}


.introTable td {
	vertical-align: top;
	width:320px;
}


.box {
	-moz-border-radius: 10px;
	-webkit-border-radius: 10px;
	border-radius:10px;
	background:#F0F0E7;
	padding: 10px;
	margin-bottom: 10px;
}

.example {
	width: 630px;
	padding: 10px;
	background: #F9F9F9;
	border: 1px solid #93BDD5;
	border-radius:10px;
	-moz-border-radius: 10px;
	-webkit-border-radius: 10px;
}

.seasideExample {
	background-color: #FBFFFA;
	border: 1px solid #93BDD5;
	margin: 1em;
	padding: 1em;
}

pre.codeSample {
	margin: 2em;
}

.sampleValue {
	color: #aaaaaa;
}

.dialog {
	-moz-border-radius: 10px;
	-webkit-border-radius: 10px;
	border-radius:10px;
	background: white;
	padding: 10px;
	border: 1px solid black;
}

'! !

WAComponent subclass: #WAWelcome
	instanceVariableNames: 'example'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Welcome'!

!WAWelcome commentStamp: '<historical>' prior: 0!
An short introduction to Seaside!

!WAWelcome class methodsFor: 'accessing' stamp: 'NickAger 5/23/2010 13:49'!
description
	^ 'An short introduction to Seaside'! !

!WAWelcome class methodsFor: 'class initialization' stamp: 'jf 5/23/2010 22:03'!
initialize
	| application |
	application := WAAdmin register: self asApplicationAt: 'welcome'.
	WAAdmin defaultDispatcher defaultName: 'welcome'.
	application
		addLibrary: JQDeploymentLibrary;
		addLibrary: JQUiDeploymentLibrary;
		addLibrary: JQUiLightnessTheme! !

!WAWelcome methodsFor: 'private' stamp: 'jf 5/23/2010 15:34'!
callback: aBlock labeled: label on: html if: makeLink
	makeLink
		ifFalse: [ html text: label ]
		ifTrue: [
			html anchor
				callback: aBlock;
				with: label ]! !

!WAWelcome methodsFor: 'hooks' stamp: 'lr 5/24/2010 10:35'!
children
	^ Array with: example! !

!WAWelcome methodsFor: 'private' stamp: 'jf 5/24/2010 01:19'!
clearServerUrl
	WAWelcomeUrlDialog clearServerUrl! !

!WAWelcome methodsFor: 'rendering' stamp: 'jf 5/23/2010 23:04'!
renderConfigurationOn: html
	html div
		class: #box;
		class: #configuration;
		with: [
			html heading level2 with: 'Configuration'.
				self renderDevToolsOn: html.
				self renderWalkbacksOn: html.
				self renderPasswordOn: html.
				self renderServerUrlOn: html.
				html paragraph: [
					html text: 'Go to full web-based '.
					html anchor url: '/config'; with: 'config app' ] ]! !

!WAWelcome methodsFor: 'rendering' stamp: 'lr 5/24/2010 10:54'!
renderContentOn: html
	self renderHeaderBarOn: html.
	html div
		class: #content;
		with: [
			self renderIntroTextOn: html.	
			html table
				class: #introTable;
				with: [ 
					html tableRow:[ 
						html tableData: [ self renderNewToSeasideOn: html ].
						html tableData: [
							self renderExperiencedUserOn: html.
							self renderConfigurationOn: html ] ] ].
		self renderExampleOn: html ]

! !

!WAWelcome methodsFor: 'rendering' stamp: 'jf 5/23/2010 15:52'!
renderDevToolsOn: html
	html paragraph: [
		html text: 'Development tools: [ '.
		self callback: [ WAAdmin enableDevelopmentTools ] labeled: 'enable' on: html if: WAAdmin developmentToolsEnabled not.
		html text: ' / '.
		self callback: [ WAAdmin disableDevelopmentTools ] labeled: 'disable' on: html if: WAAdmin developmentToolsEnabled.
		html text: ' ]' ]! !

!WAWelcome methodsFor: 'rendering' stamp: 'lr 5/24/2010 10:37'!
renderDocumentationOn: html
	html paragraph: [ 
		html text: 'The  '.
		html anchor
			url: 'http://book.seaside.st/';
			with: 'Seaside book'.
		html text: ' will teach you all you need to know about Seaside and how to build killer web applications.' ]! !

!WAWelcome methodsFor: 'rendering' stamp: 'lr 5/24/2010 10:36'!
renderExampleOn: html
	example notNil ifTrue: [
		html div
			class: #example;
			with: example ]! !

!WAWelcome methodsFor: 'rendering' stamp: 'lr 5/24/2010 10:46'!
renderExamplesOn: html
	html
		unorderedList: [ 
			html listItem: [ 
				html anchor
					callback: [ example := WAWelcomeCounterExample new ];
					with: 'Counter'.
				html text: ', a simple Seaside component.' ].
			html listItem: [
				html anchor
					callback: [ example := WAWelcomeMultiCounterExample new ];
					with: 'Multi-Counter'.
				html text: ', showing how Seaside components can be re-used.' ].
			html listItem: [ 
				html anchor
					callback: [ example := WAWelcomeTaskExample new ];
					with: 'Task'.
				html text: ', illustrating Seaside''s innovative approach to application control flow.' ] ]! !

!WAWelcome methodsFor: 'rendering' stamp: 'lr 5/24/2010 10:46'!
renderExperiencedUserOn: html
	html div
		class: #box;
		class: #experiencedUser;
		with: [
			html heading level2 with: 'Next Steps'.
			html unorderedList: [
				html listItem: [
					html anchor url: '/browse'; with: 'Browse'.
					html text: ' the applications installed in your image.' ].				
				html listItem: [
					html text: 'Join the '.
					html anchor url: 'http://www.seaside.st/community/mailinglist'; with: 'mailing list'.
					html text: ' to get help and ask questions.' ].				
				html listItem: [
					html text: 'Check out examples of Seaside''s new '.
					html anchor url: '/javascript/jquery'; with: 'JQuery'.
					html text: ' and '.
					html anchor url: '/javascript/jquery-ui'; with: 'JQuery UI'.
					html text: ' integration.' ] ] ]
		
! !

!WAWelcome methodsFor: 'rendering' stamp: 'lr 5/24/2010 10:46'!
renderHeaderBarOn: html
	html div
		class: #header;
		with: [
			html div
				class: #headerImage;
				with: [
					html anchor
						url: 'http://www.seaside.st';
						with: [
							html image 
								url: JQAllFunctionalTestsLibrary / #seastarPng;
								height: 50; 
								width: 50 ] ].
			html div
				class: #headerText;
				with: [
					html anchor
						url:  'http://www.seaside.st';
						with: [ html heading level2; with: 'Seaside ', GRPlatform current seasideVersion greaseString ] ] ]! !

!WAWelcome methodsFor: 'rendering' stamp: 'lr 5/24/2010 10:35'!
renderIntroTextOn: html
	html div
		class: #introText;
		with: [
			html heading level1; with: 'Welcome'.
			html paragraph: 'Congratulations: you have a working Seaside image.' ]! !

!WAWelcome methodsFor: 'rendering' stamp: 'lr 5/24/2010 10:36'!
renderNewToSeasideOn: html
	html div
		class: #box;
		class: #newToSeaside;
		with: [ 
			html heading level2 with: 'New to Seaside'.
			html paragraph: 'If you''re just starting out, the links below should help you find your way.'.
			html heading
				level4;
				with: 'Documentation'.
			self renderDocumentationOn: html.
			html heading
				level4;
				with: 'Examples'.
			self renderExamplesOn: html ]! !

!WAWelcome methodsFor: 'rendering' stamp: 'jf 5/23/2010 15:56'!
renderPasswordOn: html
! !

!WAWelcome methodsFor: 'rendering' stamp: 'jf 5/24/2010 18:19'!
renderServerUrlOn: html
	| id |
	html div
		id: (id := html nextId);
		class: 'dialog';
	      script: (html jQuery new dialog
			html: WAWelcomeUrlDialog new;
			title: 'Configure server URL';
			resizable: false;
			modal: true).
	html paragraph: [
		html text: 'Server URL: '; text: self serverUrl; text: ' [ '.
		html anchor
			url: '#';
			onClick: ((html jQuery id: id) dialog open return: false);
			with: 'set'.
		self serverUrl isNil ifFalse: [
			html text: ' / '.
			html anchor
				callback: [ self clearServerUrl ];
				with: 'clear' ].
		html text: ' ]' ]! !

!WAWelcome methodsFor: 'rendering' stamp: 'jf 5/23/2010 15:53'!
renderWalkbacksOn: html
	| enabled |
	enabled := (WAAdmin applicationExceptionHandlingDefaults at: #exceptionHandler) = WAWalkbackErrorHandler.
	html paragraph: [
		html text: 'Error walkbacks: [ '.
		self callback: [ WAAdmin applicationExceptionHandlingDefaults at: #exceptionHandler put: WAWalkbackErrorHandler ] labeled: 'enable' on: html if: enabled not.
		html text: ' / '.
		self callback: [ WAAdmin applicationExceptionHandlingDefaults at: #exceptionHandler put: WAHtmlErrorHandler ] labeled: 'disable' on: html if: enabled.
		html text: ' ]' ]! !

!WAWelcome methodsFor: 'private' stamp: 'jf 5/24/2010 01:21'!
serverUrl
	^ WAWelcomeUrlDialog serverUrl! !

!WAWelcome methodsFor: 'updating' stamp: 'lr 5/24/2010 10:36'!
updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.
	anHtmlRoot title: 'Welcome to Seaside'.
	anHtmlRoot link beShortcutIcon; url: WAToolFiles / #faviconIco.
	anHtmlRoot stylesheet url: WAToolFiles / #handlerCss.
	WAWelcomeFiles default updateRoot: anHtmlRoot! !

WAComponent subclass: #WAWelcomeCounterExample
	instanceVariableNames: 'counter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Welcome'!

!WAWelcomeCounterExample commentStamp: '<historical>' prior: 0!
Describes and demonstrates the code in WACounter!

!WAWelcomeCounterExample methodsFor: 'hooks' stamp: 'NickAger 5/23/2010 08:25'!
children
	^ Array with: counter! !

!WAWelcomeCounterExample methodsFor: 'initialization' stamp: 'NickAger 5/23/2010 08:14'!
initialize
	super initialize.
	
	counter := WACounter new

! !

!WAWelcomeCounterExample methodsFor: 'rendering' stamp: 'NickAger 6/9/2010 13:08'!
renderContentOn: html
	html heading level1 with: 'Counter'.
	html paragraph: 'The counter is an example of a simple Seaside component. It increments and decrements a number by clicking on a link. Test the example below by clicking on the "++" and "--" links:'.

	html div class: #seasideExample; with: counter.

	html paragraph: [		
		html text: 'This application is coded in two short methods. It is implemented in class ';	code: 'WACounter';  text: ', a subclass of '; code: 'WAComponent'
	].

	html paragraph: 'The first method initializes the counter to 0:'.

	self renderInitializeCodeOn: html.
	
	html paragraph: 'The second method generates the output and assigns the actions to the anchors (links) which update the current value.'.
	
	self renderRenderContentOnCodeOn: html.
	
! !

!WAWelcomeCounterExample methodsFor: 'rendering' stamp: 'NickAger 5/23/2010 12:02'!
renderInitializeCodeOn: html
	html preformatted class: #codeSample; with: [
		html span class: #patternUnary; with: 'initialize'. html break.
		html span class: #super; with:'    super'. html text:' initialize.'. html break.
		html span class: #instanceVar; with:'    count'. html text: ' := '. html span class: #number; with: '0'		
		].
! !

!WAWelcomeCounterExample methodsFor: 'rendering' stamp: 'NickAger 5/23/2010 12:22'!
renderRenderContentOnCodeOn: html
	html preformatted class: #codeSample; with: [
		html span class: #patternKeyword; with: 'renderContentOn: '. html span class: #patternArg; with: 'html'. html break.
    		html span class: #receiver; with: '    html'. html text: ' heading: '. html span class: #instanceVar; with: 'count.'. html break.
		html span class: #receiver; with: '    html'. html text: ' anchor'. html break.
		html text: '        callback: [ '. html span class: #instanceVar; with: 'count '. html text: ':= '. html span class: #instanceVar; with: 'count'. html text: ' + '. html span class: #number; with: '1'. html text: ' ];'. html break.
		html text: '        with: '. html span class: #string; with: '''++'''. html text: '.'. html break.
		html span class: #receiver; with: '    html'. html text: ' space.'. html break.
		html span class: #receiver; with: '    html'. html text: ' anchor'. html break.
		html text: '        callback: [ '. html span class: #instanceVar; with: 'count '. html text: ':= '. html span class: #instanceVar; with: 'count'. html text: ' - '. html span class: #number; with: '1'. html text: ' ];'. html break.
		html text: '        with: '. html span class: #string; with: '''--'''. html text: '.'.
		]! !

WAComponent subclass: #WAWelcomeMultiCounterExample
	instanceVariableNames: 'multicounter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Welcome'!

!WAWelcomeMultiCounterExample commentStamp: '<historical>' prior: 0!
Describes and demonstrates the code in WAMultiCounter!

!WAWelcomeMultiCounterExample methodsFor: 'hooks' stamp: 'NickAger 5/23/2010 08:26'!
children
	^ Array with: multicounter! !

!WAWelcomeMultiCounterExample methodsFor: 'initialization' stamp: 'NickAger 5/23/2010 08:17'!
initialize
	super initialize.
	
	multicounter := WAMultiCounter new.
! !

!WAWelcomeMultiCounterExample methodsFor: 'rendering' stamp: 'NickAger 5/23/2010 12:37'!
renderChildrenCodeOn: html
	html preformatted class: #codeSample; with: [
		html span class: #patternUnary; with: 'children'. html break.
		html text: '    ^ '. html span class: #instanceVar; with: 'counters'
		]
! !

!WAWelcomeMultiCounterExample methodsFor: 'rendering' stamp: 'NickAger 6/9/2010 13:11'!
renderContentOn: html
	html heading level1 with: 'Multi-Counter'.
	
	html paragraph: [
		html text: 'Multicounter is a simple extension to the '.
		html anchor callback: [self show: WAWelcomeCounterExample new]; with: 'Counter'.
		html text: ' application. It displays several instances of the same '.
		html anchor callback: [self show: WAWelcomeCounterExample new]; with: 'Counter'.
		html text: ' component:'
		].
	
	html div class: #seasideExample; with: multicounter.
	
	html paragraph: [
		html text: 'This component is implemented in a few lines of code. The code is contained in the class '; code: 'WAMultiCounter'; text: ', a subclass of '; code: 'WAComponent. '
	].

	html paragraph: 'The first method is used to initialize the component, in this case we instantiate 5 counters:'.
	 
	self renderInitializeCodeOn: html.
	
	html paragraph: 'We then tell Seaside which child components we intend to display. In our case this is just the collection of counter instances:'.
	
	self renderChildrenCodeOn: html.
	
	html paragraph: 'Finally we display each of the components separated by a horizontal rule:'.
	
	self renderRenderContentsOnCodeOn: html
	
! !

!WAWelcomeMultiCounterExample methodsFor: 'rendering' stamp: 'NickAger 5/23/2010 12:32'!
renderInitializeCodeOn: html
	html preformatted class: #codeSample; with: [
		html span class: #patternUnary; with: 'initialize'. html break.
		html span class: #super; with:'    super'. html text:' initialize.'. html break.
    		html span class: #instanceVar; with:'    counters'. html text: ' := ('. html span class: #number; with: '1'. html text:' to: '. html span class: #number; with: '5'. html text: ')'. html break.
		html text: '         collect: [ '. html span class: #blockArg; with: ':each'. html text: ' | '. html span class: #class; with: 'WACounter'. html text:' new ]'
		]! !

!WAWelcomeMultiCounterExample methodsFor: 'rendering' stamp: 'NickAger 5/23/2010 12:57'!
renderRenderContentsOnCodeOn: html
	html preformatted class: #codeSample; with: [
		html span class: #patternKeyword; with: 'renderContentOn: '. html span class: #patternArg; with: 'html'. html break.
    		html span class: #instanceVar; with: '    counters'. html break.
		html text: '        do: [ '. html span class: #blockArg; with: ':each'. html text: ' | '. html span class: #receiver; with: 'html'.  html text: ' render: '. html span class: #patternArg; with:'each'. html text: ' ]'. html break.
		html text: '         separatedBy: [ '.  html span class: #receiver; with: 'html'. html text: ' horizontalRule ]'
		]
! !

WAComponent subclass: #WAWelcomeTaskExample
	instanceVariableNames: 'taskExample'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Welcome'!

!WAWelcomeTaskExample commentStamp: '<historical>' prior: 0!
Describes and demonstrates the code in WAFlowConvenienceFunctionalTest
!

!WAWelcomeTaskExample methodsFor: 'hooks' stamp: 'NickAger 5/23/2010 09:48'!
children
	^ Array with: taskExample! !

!WAWelcomeTaskExample methodsFor: 'initialization' stamp: 'NickAger 5/23/2010 09:47'!
initialize
	super initialize.
	
	taskExample := WAFlowConvenienceFunctionalTest new! !

!WAWelcomeTaskExample methodsFor: 'rendering' stamp: 'NickAger 5/24/2010 10:53'!
renderChooseCheeseCodeOn: html
	html preformatted class: #codeSample; with: [
		html span class: #patternUnary; with: 'chooseCheese'. html break.
		html span class: #instanceVar; with: '    cheese'. html text: ' := '. html span class: #self; with: 'self'. html break.
		html text: '        chooseFrom: '. html span class: #symbol; with: '#'. html text: '( '. html span class: #string; with: '''Greyerzer'' ''Tilsiter'' ''Sbrinz'''. html text: ' )'. html break.
		html text:'        caption: '. html span class: #string; with: '''What''''s your favorite cheese?'''. html text: '.'. html break.
		html span class: #instanceVar; with: '    cheese'. html text: ' isNil ifTrue: [ '. html span class: #self; with: 'self'. html text:' chooseCheese ]'
		]
! !

!WAWelcomeTaskExample methodsFor: 'rendering' stamp: 'NickAger 5/24/2010 11:08'!
renderConfirmCheeseCodeOn: html
	html preformatted class: #codeSample; with: [
		html span class: #patternUnary; with: 'confirmCheese'. html break.
		html text: '    ^ '. html span class: #self; with: 'self'. html text: ' confirm: '. html span class: #string; with: '''Is '''. html text:', '. html span class: #instanceVar; with: 'cheese'. html text: ','. html span class: #string; with: ''' your favorite cheese?'''. html break
		]
! !

!WAWelcomeTaskExample methodsFor: 'rendering' stamp: 'NickAger 6/9/2010 13:17'!
renderContentOn: html
	html heading level1 with: 'Task'.
	html paragraph: 'Complex, multi-page workflows can be expressed in Seaside with a single method. Unlike many web frameworks  which require a separate handler for each page or request, Seaside models an entire user session as a continuous piece of code, with natural, linear control flow.'.

	html div class: #seasideExample; with: taskExample.
		
	html paragraph: [		
		html text: 'This example subclasses '; code: 'WATask'; text: ' and implements the hook method '; code: '#go'.
		html text: '. We store the users choice in an instance variable named '; code: 'cheese.'.
	].

	self renderGoCodeOn: html.
	
	html paragraph: [
		html text: 'To allow the user to choose from a list of famous Swiss cheeses we use the convenience method '; code: '#chooseFrom:caption:'; text: ' which returns the chosen element from a collection or '; code: 'nil'; text: ' if the user cancels the dialog. If '; code: 'nil'; text: ' is returned, we simply ask again.'
		].
	
	self renderChooseCheeseCodeOn: html.
	
	html paragraph: [
		html text: 'Then we ask the user to confirm their choice. The '; code: '#confirm:'; text: ' method answers a '; code: 'boolean:'
		].
	
	self renderConfirmCheeseCodeOn: html.
	
	html paragraph: [
		html text: 'Finally we display the user''s choice using '; code: '#inform:.'.
		].
	
	self renderInformCheeseCodeOn: html.
	
	html paragraph: 'As simple as that. And yes, the back button still works.'
		
! !

!WAWelcomeTaskExample methodsFor: 'rendering' stamp: 'NickAger 5/23/2010 13:07'!
renderGoCodeOn: html
	html preformatted class: #codeSample; with: [
		html span class: #patternUnary; with: 'go'. html break.
		html text: '    [ '. html span class: #self; with: 'self'. html text: ' chooseCheese.'. html break.
		html text: '      '. html span class: #self; with: 'self'. html text: ' confirmCheese'. html text: ' ] whileFalse.'. html break.
		html text: '    '. html span class: #self; with: 'self'. html text: ' informCheese.'
	]! !

!WAWelcomeTaskExample methodsFor: 'rendering' stamp: 'NickAger 5/23/2010 13:29'!
renderInformCheeseCodeOn: html
	html preformatted class: #codeSample; with: [
		html span class: #patternUnary; with: 'informCheese'. html break.
		html span class: #self; with: '    self'. html text: ' inform: '. html span class: #string; with: '''Your favorite is '''. html text:', '. html span class: #instanceVar; with: 'cheese'. html text: ','. html span class: #string; with: '''.'''. html break
		]! !

WAPainter subclass: #WAWelcomeUrlDialog
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Welcome'!

!WAWelcomeUrlDialog class methodsFor: 'urls' stamp: 'jf 5/24/2010 01:19'!
clearServerUrl
	WAAdmin defaultDispatcher
		serverProtocol: nil;
		serverHostname: nil;
		serverPort: nil;
		serverPath: nil! !

!WAWelcomeUrlDialog class methodsFor: 'urls' stamp: 'jf 5/24/2010 01:18'!
serverUrl
	| dispatcher |
	dispatcher := WAAdmin defaultDispatcher.
	(dispatcher serverProtocol isNil and: [ dispatcher serverHostname isNil and: [
		dispatcher serverPort isNil and: [ dispatcher serverPath isNil ] ] ])
			ifTrue: [ ^ nil ].
	^ dispatcher url! !

!WAWelcomeUrlDialog class methodsFor: 'urls' stamp: 'jf 5/24/2010 01:18'!
serverUrl: aUrl
	WAAdmin defaultDispatcher
		serverProtocol: aUrl scheme;
		serverHostname: aUrl host;
		serverPort: aUrl port;
		serverPath: aUrl pathString! !

!WAWelcomeUrlDialog methodsFor: 'rendering' stamp: 'jf 5/24/2010 01:20'!
renderContentOn: html
	| url input |
	html form
		onSubmit: (html javascript return: false);
		with: [ 
			(input := html textInput)
				value: self serverUrl greaseString;
				callback: [ :urlString | url := WAUrl absolute: urlString ].
			self serverUrl isNil ifTrue: [ 
				"Setup a sample string"
				input
					value: 'http://localhost:8080/';
					class: 'sampleValue';
					script:
						(html jQuery this onFocus:
							((html jQuery this)
								value: '';
								removeClass: 'sampleValue';
								unbind: 'focus')) ].
			html button
				bePush;
				onClick:
					(((html jQuery: #confirm) load)
						html: '';
						serializeForm;
						html: [ :r | self renderTryingUrl: url on: r ]);
				with: 'Test' ].
	html div id: 'confirm'! !

!WAWelcomeUrlDialog methodsFor: 'rendering' stamp: 'jf 5/24/2010 01:04'!
renderSuccessUrl: url on: html
	html paragraph: [ 
		html text: 'Success!! '.
		html button
			bePush;
			onClick:
				((html jQuery ajax)
					callback: [ self serverUrl: url ];
					onComplete: html javascript refresh);
		with: 'Update Configuration' ]! !

!WAWelcomeUrlDialog methodsFor: 'rendering' stamp: 'jf 5/24/2010 01:06'!
renderTryingUrl: url on: html
	| testUrl |
	testUrl := url copy addAllToPath: (WAAdmin defaultDispatcher url relativeTo: self requestContext handler url).
	html paragraph: 'Trying ' , testUrl greaseString , ' ...'.
	html script:
		((html jQuery ajax)
			script: [ :s | 
				s <<
					(s jQuery: '#confirm')
						append: [ :r |  self renderSuccessUrl: url on: r ] ];
						optionAt: 'url' put: testUrl;
						yourself)! !

!WAWelcomeUrlDialog methodsFor: 'private' stamp: 'jf 5/24/2010 01:18'!
serverUrl
	^ self class serverUrl! !

!WAWelcomeUrlDialog methodsFor: 'private' stamp: 'jf 5/24/2010 01:19'!
serverUrl: aUrl
	self class serverUrl: aUrl! !

!GRPackage class methodsFor: '*seaside-welcome' stamp: 'jf 5/24/2010 01:48'!
seasideWelcome
	^ self new
		name: 'Seaside-Welcome';
		description: 'A welcome screen for new users.';
		addDependency: 'Seaside-Environment';
		addDependency: 'Seaside-Tools-Web';
		addDependency: 'Seaside-Examples';
		addDependency: 'Seaside-Development';
		url: #seasideUrl;
		yourself! !
WAWelcome initialize!
